
#include <stdlib.h>
#include <stdio.h>
#include <math.h>
#include <string.h>
#include <unistd.h>
#include <sys/time.h>
#include <sys/types.h>
#include <sys/wait.h>
#include <signal.h>
#include <time.h>

#include <SDL/SDL.h>
#include <SDL/SDL_video.h>
#include <SDL/SDL_keysym.h>
#include <GL/gl.h>
#include <GL/glu.h>

#include "defines.h"
#include "main.h"
#include "sdl.h"
#include "opengl.h"
#include "../vsofont.h"


/* quit key status */
int quit = NO;

/* example fonts */
struct vsofont *examplefont, *clone, *proportional;



int main(int argc, char *argv[]) {

  srand(time(NULL));

  /* load the font */
  if (vsofont_read_font_from_file("example.vsofont", &examplefont) == FAILED)
    return 1;

  /* alter it */
  vsofont_recreate_vertices(examplefont, 0.1, 0.1);
  vsofont_set_spacing(examplefont, 0.05);

  /* clone it */
  vsofont_clone(examplefont, &clone);

  /* make the clone look different */
  vsofont_set_color(clone, 0.0, 0.5, 1.0, 1.0);
  vsofont_set_spacing(clone, 0.02);

  /* clone again */
  vsofont_clone(clone, &proportional);

  /* make the clone look different */
  vsofont_set_type(proportional, VSOFONT_TYPE_PROPORTIONAL);
  vsofont_set_color(proportional, 0.7, 0.5, 1.0, 1.0);
  vsofont_set_spacing(proportional, 0.01);

  vsofont_recreate_vertices(clone, 0.05, 0.05);

  if (sdl_init() == FAILED)
    return 1;
  if (opengl_init() == FAILED)
    return 1;

  while (quit == NO) {
    sdl_keyboard_io();
    opengl_render_scene();
  }

  /* free the fonts */
  vsofont_free(clone);
  vsofont_free(proportional);
  vsofont_free(examplefont);

  opengl_exit();
  sdl_exit();

  return 0;
}
