
#include <stdlib.h>
#include <stdio.h>
#include <math.h>
#include <string.h>
#include <unistd.h>
#include <sys/time.h>
#include <sys/types.h>
#include <sys/wait.h>
#include <signal.h>
#include <time.h>

#include <SDL/SDL.h>
#include <SDL/SDL_video.h>
#include <SDL/SDL_keysym.h>
#include <GL/gl.h>
#include <GL/glu.h>

#include "defines.h"
#include "opengl.h"
#include "../vsofont.h"


/* example fonts */
extern struct vsofont *examplefont, *clone, *proportional;

/* zooming */
float zoom = 1.0;



int opengl_init(void) {

  glClearColor(0, 0, 0, 1);
  glShadeModel(GL_FLAT);
  glDepthMask(GL_FALSE);

  glDisable(GL_CULL_FACE);
  glDisable(GL_DEPTH_TEST);
  glDisable(GL_TEXTURE_2D);
  glDisable(GL_BLEND);
  glDisable(GL_LIGHTING);
  glDisable(GL_CULL_FACE);
  glDisable(GL_FOG);
  glDisable(GL_NORMALIZE);
  glBindTexture(GL_TEXTURE_2D, 0);

  glEnableClientState(GL_VERTEX_ARRAY);

  return SUCCEEDED;
}


int opengl_exit(void) {

  return SUCCEEDED;
}


int opengl_render_scene(void) {

  GLfloat vertices[7*2];
  char tmp[256];


  glClear(GL_COLOR_BUFFER_BIT);

  glMatrixMode(GL_PROJECTION);
  glLoadIdentity();
  glOrtho(-1, 1, -1, 1, 0, 0);
 
  glMatrixMode(GL_MODELVIEW);
  glLoadIdentity();

  vsofont_write_string_billboard_centered(examplefont, "Examplefont", 0, 0, 0);
  vsofont_write_string_billboard(clone, "CLONE", 0, -0.2, 0);
  vsofont_write_string_billboard_centered(proportional, "PROPORTIONAL", 0, -0.4, 0);
  vsofont_write_string_2D_centered(proportional, "NIIIIIICE", 0, -0.8);

  glLineWidth(2);
  vsofont_write_string_2D(proportional, "Proportional", -0.1, -0.6);
  glLineWidth(1);

  sprintf(tmp, "INTERESTING:%c%c%c%c", 3, 1, 2, 0);
  vsofont_write_string_2D_centered(proportional, tmp, 0, 0.2);

  /* antialiasing */
  glEnable(GL_LINE_SMOOTH);
  glHint(GL_LINE_SMOOTH, GL_NICEST);
  glEnable(GL_BLEND);
  glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);

  vsofont_write_string_2D_centered(proportional, "ANTIALIASED", 0, 0.4);

  glDisable(GL_LINE_SMOOTH);
  glDisable(GL_BLEND);

  glPointSize(5);
  glColor3f(0.8, 0, 0);

  vertices[0*2+0] = 0.0;
  vertices[0*2+1] = 0.2;
  vertices[1*2+0] = 0.0;
  vertices[1*2+1] = 0.0;
  vertices[2*2+0] = 0.0;
  vertices[2*2+1] = -0.2;
  vertices[3*2+0] = 0.0;
  vertices[3*2+1] = -0.4;
  vertices[4*2+0] = -0.1;
  vertices[4*2+1] = -0.6;
  vertices[5*2+0] = 0.0;
  vertices[5*2+1] = -0.8;
  vertices[6*2+0] = 0.0;
  vertices[6*2+1] = 0.4;

  glVertexPointer(2, GL_FLOAT, 0, vertices);
  glDrawArrays(GL_POINTS, 0, 7);

  SDL_GL_SwapBuffers();

  return SUCCEEDED;
}
